/*
** ###################################################################
**     This code is generated by the Device Initialization Tool.
**     It is overwritten during code generation.
**     USER MODIFICATION ARE PRESERVED ONLY INSIDE INTERRUPT SERVICE ROUTINES
**     OR EXPLICITLY MARKED SECTIONS
**
**     Project   : NRF24L01P
**     Processor : MC9S12XS128MAA
**     Version   : Component 01.003, Driver 01.05, CPU db: 3.00.019
**     Datasheet : MC9S12XS256RMV1 Rev. 1.03 06/2008
**     Date/Time : 2011-3-31, 17:19
**     Abstract  :
**         This module contains device initialization code 
**         for selected on-chip peripherals.
**     Contents  :
**         Function "MCU_init" initializes selected peripherals
**
**     Copyright : 1997 - 2010 Freescale Semiconductor, Inc. All Rights Reserved.
**     
**     http      : www.freescale.com
**     mail      : support@freescale.com
** ###################################################################
*/
/* MODULE MCUinit */

#include <MC9S12XS128.h>               /* I/O map for MC9S12XS128MAA */
#include "MCUinit.h"

/* Standard ANSI C types */
#ifndef int8_t
typedef signed char int8_t;
#endif
#ifndef int16_t
typedef signed int   int16_t;
#endif
#ifndef int32_t
typedef signed long int    int32_t;
#endif

#ifndef uint8_t
typedef unsigned char       uint8_t;
#endif
#ifndef uint16_t
typedef unsigned int  uint16_t;
#endif
#ifndef uint32_t
typedef unsigned long int   uint32_t;
#endif

#define CGM_DELAY  7679U

/* User declarations and definitions */
#include "NRF24L01.h"
/*	 Code, declarations and definitions here will be preserved during code generation */
/* End of user declarations and definitions */

extern void near _Startup(void);

#pragma CODE_SEG __NEAR_SEG NON_BANKED

static void MCU_init_reset(void);
/*
** ===================================================================
**     Method      :  MCU_init_reset (component MC9S12XS256_80)
**
**     Description :
**         Device initialization code for after reset initialization.
** ===================================================================
*/
static void MCU_init_reset(void)
{

  /*  Initialization of memory configuration */
  /* MMCCTL1: MGRAMON=0,DFIFRON=0,PGMIFRON=0 */
  MMCCTL1 = 0U;                                      
  /* DIRECT: DP15=0,DP14=0,DP13=0,DP12=0,DP11=0,DP10=0,DP9=0,DP8=0 */
  DIRECT = 0U;                                      
  /* IVBR: IVB_ADDR=255 */
  IVBR = 255U;                                      
  /* ECLKCTL: NECLK=1,NCLKX2=1,DIV16=0,EDIV4=0,EDIV3=0,EDIV2=0,EDIV1=0,EDIV0=0 */
  ECLKCTL = 192U;                                      
  /* Jump to the default entry point */
  /*lint -save  -e950 Disable MISRA rule (1.1) checking. */
  asm jmp _Startup;
  /*lint -restore Enable MISRA rule (1.1) checking. */
} /*MCU_init*/

#pragma CODE_SEG DEFAULT
#pragma MESSAGE DISABLE C12056



/*
** ===================================================================
**     Method      :  MCU_init (component MC9S12XS256_80)
**
**     Description :
**         Device initialization code for selected peripherals.
** ===================================================================
*/
void MCU_init(void)
{

  /* ### MC9S12XS256_80 "Cpu" init code ... */
  /*  PE initialization code after reset */
  /*  System clock initialization */
  /* CLKSEL: PLLSEL=0,PSTP=0,XCLKS=0,PLLWAI=0,RTIWAI=0,COPWAI=0 */
  CLKSEL = 0U;                         /* Select clock source from XTAL and set bits in CLKSEL reg. */
  /* PLLCTL: CME=1,PLLON=0,FM1=0,FM0=0,FSTWKP=0,PRE=0,PCE=0,SCME=1 */
  PLLCTL = 129U;                       /* Disable the PLL */
  /* SYNR: VCOFRQ1=1,VCOFRQ0=1,SYNDIV5=0,SYNDIV4=0,SYNDIV3=1,SYNDIV2=1,SYNDIV1=1,SYNDIV0=0 */
  SYNR = 206U;                         /* Set the multiplier register */
  /* REFDV: REFFRQ1=0,REFFRQ0=1,REFDIV5=0,REFDIV4=0,REFDIV3=0,REFDIV2=0,REFDIV1=1,REFDIV0=1 */
  REFDV = 67U;                         /* Set the divider register */
  /* POSTDIV: POSTDIV4=0,POSTDIV3=0,POSTDIV2=0,POSTDIV1=0,POSTDIV0=0 */
  POSTDIV = 0U;                        /* Set the post divider register */
  /* PLLCTL: CME=1,PLLON=1,FM1=0,FM0=0,FSTWKP=0,PRE=0,PCE=0,SCME=1 */
  PLLCTL = 193U;                                      
  while(CRGFLG_LOCK == 0U) {           /* Wait until the PLL is within the desired tolerance of the target frequency */
  }
  /* CLKSEL: PLLSEL=1 */
  CLKSEL |= (unsigned char)128U;       /* Select clock source from PLL */
  /* VREGHTCL: VSEL=0,VAE=1,HTEN=0,HTDS=0,HTIE=0,HTIF=0 */
  VREGHTCL = 16U;                                      
  /* Int. priority initialization */
  /*                                        No. Address Pri XGATE Name           Description */
  INT_CFADDR = 16U;                                      
  INT_CFDATA2 = 1U;                    /*  0x0A  0xFF14   1   no   ivVReserved118 unused by PE */
  INT_CFDATA3 = 1U;                    /*  0x0B  0xFF16   1   no   ivVReserved117 unused by PE */
  INT_CFDATA4 = 1U;                    /*  0x0C  0xFF18   1   no   ivVReserved116 unused by PE */
  INT_CFDATA5 = 1U;                    /*  0x0D  0xFF1A   1   no   ivVReserved115 unused by PE */
  INT_CFDATA6 = 1U;                    /*  0x0E  0xFF1C   1   no   ivVReserved114 unused by PE */
  INT_CFDATA7 = 1U;                    /*  0x0F  0xFF1E   1   no   ivVReserved113 unused by PE */
  INT_CFADDR = 32U;                                      
  INT_CFDATA0 = 1U;                    /*  0x10  0xFF20   1   no   ivVReserved112 unused by PE */
  INT_CFDATA1 = 1U;                    /*  0x11  0xFF22   1   no   ivVReserved111 unused by PE */
  INT_CFDATA2 = 1U;                    /*  0x12  0xFF24   1   no   ivVReserved110 unused by PE */
  INT_CFDATA3 = 1U;                    /*  0x13  0xFF26   1   no   ivVReserved109 unused by PE */
  INT_CFDATA4 = 1U;                    /*  0x14  0xFF28   1   no   ivVReserved108 unused by PE */
  INT_CFDATA5 = 1U;                    /*  0x15  0xFF2A   1   no   ivVReserved107 unused by PE */
  INT_CFDATA6 = 1U;                    /*  0x16  0xFF2C   1   no   ivVReserved106 unused by PE */
  INT_CFDATA7 = 1U;                    /*  0x17  0xFF2E   1   no   ivVReserved105 unused by PE */
  INT_CFADDR = 48U;                                      
  INT_CFDATA0 = 1U;                    /*  0x18  0xFF30   1   no   ivVReserved104 unused by PE */
  INT_CFDATA1 = 1U;                    /*  0x19  0xFF32   1   no   ivVReserved103 unused by PE */
  INT_CFDATA2 = 1U;                    /*  0x1A  0xFF34   1   no   ivVReserved102 unused by PE */
  INT_CFDATA3 = 1U;                    /*  0x1B  0xFF36   1   no   ivVReserved101 unused by PE */
  INT_CFDATA4 = 1U;                    /*  0x1C  0xFF38   1   no   ivVReserved100 unused by PE */
  INT_CFDATA5 = 1U;                    /*  0x1D  0xFF3A   1   no   ivVReserved99  unused by PE */
  INT_CFDATA6 = 1U;                    /*  0x1E  0xFF3C   1   no   ivVReserved98  unused by PE */
  INT_CFDATA7 = 1U;                    /*  0x1F  0xFF3E   1   no   ivVatd0compare unused by PE */
  INT_CFADDR = 64U;                                      
  INT_CFDATA0 = 1U;                    /*  0x20  0xFF40   1   no   ivVReserved96  unused by PE */
  INT_CFDATA1 = 1U;                    /*  0x21  0xFF42   1   no   ivVReserved95  unused by PE */
  INT_CFDATA2 = 1U;                    /*  0x22  0xFF44   1   no   ivVReserved94  unused by PE */
  INT_CFDATA3 = 1U;                    /*  0x23  0xFF46   1   no   ivVReserved93  unused by PE */
  INT_CFDATA4 = 1U;                    /*  0x24  0xFF48   1   no   ivVReserved92  unused by PE */
  INT_CFDATA5 = 1U;                    /*  0x25  0xFF4A   1   no   ivVReserved91  unused by PE */
  INT_CFDATA6 = 1U;                    /*  0x26  0xFF4C   1   no   ivVReserved90  unused by PE */
  INT_CFDATA7 = 1U;                    /*  0x27  0xFF4E   1   no   ivVReserved89  unused by PE */
  INT_CFADDR = 80U;                                      
  INT_CFDATA0 = 1U;                    /*  0x28  0xFF50   1   no   ivVReserved88  unused by PE */
  INT_CFDATA1 = 1U;                    /*  0x29  0xFF52   1   no   ivVReserved87  unused by PE */
  INT_CFDATA2 = 1U;                    /*  0x2A  0xFF54   1   no   ivVReserved86  unused by PE */
  INT_CFDATA3 = 1U;                    /*  0x2B  0xFF56   1   no   ivVReserved85  unused by PE */
  INT_CFDATA4 = 1U;                    /*  0x2C  0xFF58   1   no   ivVReserved84  unused by PE */
  INT_CFDATA5 = 1U;                    /*  0x2D  0xFF5A   1   no   ivVReserved83  unused by PE */
  INT_CFDATA6 = 1U;                    /*  0x2E  0xFF5C   1   no   ivVReserved82  unused by PE */
  INT_CFDATA7 = 1U;                    /*  0x2F  0xFF5E   1   no   ivVReserved81  unused by PE */
  INT_CFADDR = 96U;                                      
  INT_CFDATA0 = 1U;                    /*  0x30  0xFF60   1   no   ivVReserved79  unused by PE */
  INT_CFDATA1 = 1U;                    /*  0x31  0xFF62   1   no   ivVReserved78  unused by PE */
  INT_CFDATA2 = 1U;                    /*  0x32  0xFF64   1   no   ivVReserved77  unused by PE */
  INT_CFDATA3 = 1U;                    /*  0x33  0xFF66   1   no   ivVReserved76  unused by PE */
  INT_CFDATA4 = 1U;                    /*  0x34  0xFF68   1   no   ivVReserved75  unused by PE */
  INT_CFDATA5 = 1U;                    /*  0x35  0xFF6A   1   no   ivVReserved74  unused by PE */
  INT_CFDATA6 = 1U;                    /*  0x36  0xFF6C   1   no   ivVReserved73  unused by PE */
  INT_CFDATA7 = 1U;                    /*  0x37  0xFF6E   1   no   ivVReserved72  unused by PE */
  INT_CFADDR = 112U;                                      
  INT_CFDATA0 = 1U;                    /*  0x38  0xFF70   1   no   ivVReserved71  unused by PE */
  INT_CFDATA1 = 1U;                    /*  0x39  0xFF72   1   no   ivVReserved70  unused by PE */
  INT_CFDATA2 = 1U;                    /*  0x3A  0xFF74   1   no   ivVpit3        unused by PE */
  INT_CFDATA3 = 1U;                    /*  0x3B  0xFF76   1   no   ivVpit2        unused by PE */
  INT_CFDATA4 = 1U;                    /*  0x3C  0xFF78   1   no   ivVpit1        unused by PE */
  INT_CFDATA5 = 1U;                    /*  0x3D  0xFF7A   1   no   ivVpit0        unused by PE */
  INT_CFDATA6 = 1U;                    /*  0x3E  0xFF7C   1   -    ivVhti         unused by PE */
  INT_CFDATA7 = 1U;                    /*  0x3F  0xFF7E   1   no   ivVapi         unused by PE */
  INT_CFADDR = 128U;                                      
  INT_CFDATA0 = 1U;                    /*  0x40  0xFF80   1   no   ivVlvi         unused by PE */
  INT_CFDATA1 = 1U;                    /*  0x41  0xFF82   1   no   ivVReserved62  unused by PE */
  INT_CFDATA2 = 1U;                    /*  0x42  0xFF84   1   no   ivVReserved61  unused by PE */
  INT_CFDATA3 = 1U;                    /*  0x43  0xFF86   1   no   ivVReserved60  unused by PE */
  INT_CFDATA4 = 1U;                    /*  0x44  0xFF88   1   no   ivVReserved59  unused by PE */
  INT_CFDATA5 = 1U;                    /*  0x45  0xFF8A   1   no   ivVReserved58  unused by PE */
  INT_CFDATA6 = 1U;                    /*  0x46  0xFF8C   1   no   ivVpwmesdn     unused by PE */
  INT_CFDATA7 = 1U;                    /*  0x47  0xFF8E   1   no   ivVportp       unused by PE */
  INT_CFADDR = 144U;                                      
  INT_CFDATA0 = 1U;                    /*  0x48  0xFF90   1   no   ivVReserved55  unused by PE */
  INT_CFDATA1 = 1U;                    /*  0x49  0xFF92   1   no   ivVReserved54  unused by PE */
  INT_CFDATA2 = 1U;                    /*  0x4A  0xFF94   1   no   ivVReserved53  unused by PE */
  INT_CFDATA3 = 1U;                    /*  0x4B  0xFF96   1   no   ivVReserved52  unused by PE */
  INT_CFDATA4 = 1U;                    /*  0x4C  0xFF98   1   no   ivVReserved51  unused by PE */
  INT_CFDATA5 = 1U;                    /*  0x4D  0xFF9A   1   no   ivVReserved50  unused by PE */
  INT_CFDATA6 = 1U;                    /*  0x4E  0xFF9C   1   no   ivVReserved49  unused by PE */
  INT_CFDATA7 = 1U;                    /*  0x4F  0xFF9E   1   no   ivVReserved48  unused by PE */
  INT_CFADDR = 160U;                                      
  INT_CFDATA0 = 1U;                    /*  0x50  0xFFA0   1   no   ivVReserved47  unused by PE */
  INT_CFDATA1 = 1U;                    /*  0x51  0xFFA2   1   no   ivVReserved46  unused by PE */
  INT_CFDATA2 = 1U;                    /*  0x52  0xFFA4   1   no   ivVReserved45  unused by PE */
  INT_CFDATA3 = 1U;                    /*  0x53  0xFFA6   1   no   ivVReserved44  unused by PE */
  INT_CFDATA4 = 1U;                    /*  0x54  0xFFA8   1   no   ivVReserved43  unused by PE */
  INT_CFDATA5 = 1U;                    /*  0x55  0xFFAA   1   no   ivVReserved42  unused by PE */
  INT_CFDATA6 = 1U;                    /*  0x56  0xFFAC   1   no   ivVReserved41  unused by PE */
  INT_CFDATA7 = 1U;                    /*  0x57  0xFFAE   1   no   ivVReserved40  unused by PE */
  INT_CFADDR = 176U;                                      
  INT_CFDATA0 = 1U;                    /*  0x58  0xFFB0   1   no   ivVcan0tx      unused by PE */
  INT_CFDATA1 = 1U;                    /*  0x59  0xFFB2   1   no   ivVcan0rx      unused by PE */
  INT_CFDATA2 = 1U;                    /*  0x5A  0xFFB4   1   no   ivVcan0err     unused by PE */
  INT_CFDATA3 = 1U;                    /*  0x5B  0xFFB6   1   no   ivVcan0wkup    unused by PE */
  INT_CFDATA4 = 1U;                    /*  0x5C  0xFFB8   1   no   ivVflash       unused by PE */
  INT_CFDATA5 = 1U;                    /*  0x5D  0xFFBA   1   no   ivVflashfd     unused by PE */
  INT_CFDATA6 = 1U;                    /*  0x5E  0xFFBC   1   no   ivVReserved33  unused by PE */
  INT_CFDATA7 = 1U;                    /*  0x5F  0xFFBE   1   no   ivVReserved32  unused by PE */
  INT_CFADDR = 192U;                                      
  INT_CFDATA0 = 1U;                    /*  0x60  0xFFC0   1   no   ivVReserved31  unused by PE */
  INT_CFDATA1 = 1U;                    /*  0x61  0xFFC2   1   no   ivVReserved30  unused by PE */
  INT_CFDATA2 = 1U;                    /*  0x62  0xFFC4   1   no   ivVcrgscm      unused by PE */
  INT_CFDATA3 = 1U;                    /*  0x63  0xFFC6   1   no   ivVcrgplllck   unused by PE */
  INT_CFDATA4 = 1U;                    /*  0x64  0xFFC8   1   no   ivVReserved27  unused by PE */
  INT_CFDATA5 = 1U;                    /*  0x65  0xFFCA   1   no   ivVReserved26  unused by PE */
  INT_CFDATA6 = 1U;                    /*  0x66  0xFFCC   1   no   ivVReserved25  unused by PE */
  INT_CFDATA7 = 1U;                    /*  0x67  0xFFCE   1   no   ivVportj       used by PE */
  INT_CFADDR = 208U;                                      
  INT_CFDATA0 = 1U;                    /*  0x68  0xFFD0   1   no   ivVReserved23  unused by PE */
  INT_CFDATA1 = 1U;                    /*  0x69  0xFFD2   1   no   ivVatd0        unused by PE */
  INT_CFDATA2 = 1U;                    /*  0x6A  0xFFD4   1   no   ivVsci1        unused by PE */
  INT_CFDATA3 = 1U;                    /*  0x6B  0xFFD6   1   no   ivVsci0        unused by PE */
  INT_CFDATA4 = 1U;                    /*  0x6C  0xFFD8   1   no   ivVspi0        used by PE */
  INT_CFDATA5 = 1U;                    /*  0x6D  0xFFDA   1   no   ivVtimpaie     unused by PE */
  INT_CFDATA6 = 1U;                    /*  0x6E  0xFFDC   1   no   ivVtimpaaovf   unused by PE */
  INT_CFDATA7 = 1U;                    /*  0x6F  0xFFDE   1   no   ivVtimovf      unused by PE */
  INT_CFADDR = 224U;                                      
  INT_CFDATA0 = 1U;                    /*  0x70  0xFFE0   1   no   ivVtimch7      unused by PE */
  INT_CFDATA1 = 1U;                    /*  0x71  0xFFE2   1   no   ivVtimch6      unused by PE */
  INT_CFDATA2 = 1U;                    /*  0x72  0xFFE4   1   no   ivVtimch5      unused by PE */
  INT_CFDATA3 = 1U;                    /*  0x73  0xFFE6   1   no   ivVtimch4      unused by PE */
  INT_CFDATA4 = 1U;                    /*  0x74  0xFFE8   1   no   ivVtimch3      unused by PE */
  INT_CFDATA5 = 1U;                    /*  0x75  0xFFEA   1   no   ivVtimch2      unused by PE */
  INT_CFDATA6 = 1U;                    /*  0x76  0xFFEC   1   no   ivVtimch1      unused by PE */
  INT_CFDATA7 = 1U;                    /*  0x77  0xFFEE   1   no   ivVtimch0      unused by PE */
  INT_CFADDR = 240U;                                      
  INT_CFDATA0 = 1U;                    /*  0x78  0xFFF0   1   no   ivVrti         unused by PE */
  INT_CFDATA1 = 1U;                    /*  0x79  0xFFF2   1   no   ivVirq         unused by PE */
  /* Common initialization of the CPU registers */
  /* MODRR: MODRR4=1 */
  MODRR |= (unsigned char)16U;                      
  /* COPCTL: WCOP=0,RSBCK=0,WRTMASK=0,CR2=0,CR1=0,CR0=0 */
  COPCTL = 0U;                                      
  /* IRQCR: IRQEN=0 */
  IRQCR &= (unsigned char)~(unsigned char)64U;                     
  /* ### Init_SPI init code */
  /* SPI0BR: SPPR2=0,SPPR1=0,SPPR0=0,SPR2=0,SPR1=1,SPR0=0 */
  SPI0BR = 2U;                                      
  /* SPI0CR1: SPIE=0,SPE=1,SPTIE=0,MSTR=1,CPOL=0,CPHA=0,SSOE=0,LSBFE=0 */
  SPI0CR1 = 80U;                                      
  /* ### Init_GPIO init code */
  /* DDRE: DDRE7=1 */
  DDRE |= (unsigned char)128U;                      
  /* ### Init_GPIO init code */
  /* PERJ: PERJ7=0 */
  PERJ &= (unsigned char)~(unsigned char)128U;                     
  /* PIEJ: PIEJ7=1,PIEJ6=0,PIEJ1=0,PIEJ0=0 */
  PIEJ = 128U;                                      
  /* ### Init_GPIO init code */
  /* DDRM: DDRM3=1 */
  DDRM |= (unsigned char)8U;                      
  /* ### */
  /* Initial interrupt priority */
  /*lint -save  -e950 Disable MISRA rule (1.1) checking. */
  asm CLI;                             /* Enable interrupts */
  /*lint -restore Enable MISRA rule (1.1) checking. */
} /*MCU_init*/

#pragma MESSAGE DEFAULT C12056

/*lint -save  -e765 Disable MISRA rule (8.10) checking. */
#pragma CODE_SEG __NEAR_SEG NON_BANKED
/*
** ===================================================================
**     Interrupt handler : isr_default
**
**     Description :
**         User interrupt service routine. 
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
__interrupt void isr_default(void)
{
	/* Write your interrupt code here ... */

}
/* end of isr_default */
#pragma CODE_SEG DEFAULT


#pragma CODE_SEG __NEAR_SEG NON_BANKED
/*
** ===================================================================
**     Interrupt handler : isrVportj
**
**     Description :
**         User interrupt service routine. 
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
__interrupt void isrVportj(void)
{
	/* Write your interrupt code here ... */
	nRF24L01_RxPacket(NRF24L01P_Buffer_Rx);
	//PIFJ_PIFJ7=1;
	asm(MOVB #128,PIFJ);
}
/* end of isrVportj */
#pragma CODE_SEG DEFAULT


#pragma CODE_SEG __NEAR_SEG NON_BANKED
/*
** ===================================================================
**     Interrupt handler : isrVspi0
**
**     Description :
**         User interrupt service routine. 
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
__interrupt void isrVspi0(void)
{
	/* Write your interrupt code here ... */

}
/* end of isrVspi0 */
#pragma CODE_SEG DEFAULT


/*lint -restore Enable MISRA rule (8.10) checking. */

/*lint -save  -e950 Disable MISRA rule (1.1) checking. */
/* Initialization of the CPU registers in FLASH */
/*lint -restore Enable MISRA rule (1.1) checking. */




/* Interrupt vector table */


/* ISR prototype */
typedef void (*near tIsrFunc)(void);

#ifndef UNASSIGNED_ISR
  #define UNASSIGNED_ISR isr_default   /* unassigned interrupt service routine */
#endif
/*lint -save  -e950 Disable MISRA rule (1.1) checking. */
static const tIsrFunc _InterruptVectorTable[] @0xFF10U = { /* Interrupt vector table */
/*lint -restore Enable MISRA rule (1.1) checking. */
  /* ISR name                               No.  Address  Pri Name           Description */
  &UNASSIGNED_ISR,                      /* 0x08  0xFF10   -   ivVsi          unused by PE */
  &UNASSIGNED_ISR,                      /* 0x09  0xFF12   -   ivVsyscall     unused by PE */
  &UNASSIGNED_ISR,                      /* 0x0A  0xFF14   1   ivVReserved118 unused by PE */
  &UNASSIGNED_ISR,                      /* 0x0B  0xFF16   1   ivVReserved117 unused by PE */
  &UNASSIGNED_ISR,                      /* 0x0C  0xFF18   1   ivVReserved116 unused by PE */
  &UNASSIGNED_ISR,                      /* 0x0D  0xFF1A   1   ivVReserved115 unused by PE */
  &UNASSIGNED_ISR,                      /* 0x0E  0xFF1C   1   ivVReserved114 unused by PE */
  &UNASSIGNED_ISR,                      /* 0x0F  0xFF1E   1   ivVReserved113 unused by PE */
  &UNASSIGNED_ISR,                      /* 0x10  0xFF20   1   ivVReserved112 unused by PE */
  &UNASSIGNED_ISR,                      /* 0x11  0xFF22   1   ivVReserved111 unused by PE */
  &UNASSIGNED_ISR,                      /* 0x12  0xFF24   1   ivVReserved110 unused by PE */
  &UNASSIGNED_ISR,                      /* 0x13  0xFF26   1   ivVReserved109 unused by PE */
  &UNASSIGNED_ISR,                      /* 0x14  0xFF28   1   ivVReserved108 unused by PE */
  &UNASSIGNED_ISR,                      /* 0x15  0xFF2A   1   ivVReserved107 unused by PE */
  &UNASSIGNED_ISR,                      /* 0x16  0xFF2C   1   ivVReserved106 unused by PE */
  &UNASSIGNED_ISR,                      /* 0x17  0xFF2E   1   ivVReserved105 unused by PE */
  &UNASSIGNED_ISR,                      /* 0x18  0xFF30   1   ivVReserved104 unused by PE */
  &UNASSIGNED_ISR,                      /* 0x19  0xFF32   1   ivVReserved103 unused by PE */
  &UNASSIGNED_ISR,                      /* 0x1A  0xFF34   1   ivVReserved102 unused by PE */
  &UNASSIGNED_ISR,                      /* 0x1B  0xFF36   1   ivVReserved101 unused by PE */
  &UNASSIGNED_ISR,                      /* 0x1C  0xFF38   1   ivVReserved100 unused by PE */
  &UNASSIGNED_ISR,                      /* 0x1D  0xFF3A   1   ivVReserved99  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x1E  0xFF3C   1   ivVReserved98  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x1F  0xFF3E   1   ivVatd0compare unused by PE */
  &UNASSIGNED_ISR,                      /* 0x20  0xFF40   1   ivVReserved96  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x21  0xFF42   1   ivVReserved95  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x22  0xFF44   1   ivVReserved94  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x23  0xFF46   1   ivVReserved93  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x24  0xFF48   1   ivVReserved92  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x25  0xFF4A   1   ivVReserved91  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x26  0xFF4C   1   ivVReserved90  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x27  0xFF4E   1   ivVReserved89  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x28  0xFF50   1   ivVReserved88  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x29  0xFF52   1   ivVReserved87  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x2A  0xFF54   1   ivVReserved86  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x2B  0xFF56   1   ivVReserved85  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x2C  0xFF58   1   ivVReserved84  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x2D  0xFF5A   1   ivVReserved83  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x2E  0xFF5C   1   ivVReserved82  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x2F  0xFF5E   1   ivVReserved81  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x30  0xFF60   1   ivVReserved79  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x31  0xFF62   1   ivVReserved78  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x32  0xFF64   1   ivVReserved77  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x33  0xFF66   1   ivVReserved76  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x34  0xFF68   1   ivVReserved75  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x35  0xFF6A   1   ivVReserved74  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x36  0xFF6C   1   ivVReserved73  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x37  0xFF6E   1   ivVReserved72  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x38  0xFF70   1   ivVReserved71  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x39  0xFF72   1   ivVReserved70  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x3A  0xFF74   1   ivVpit3        unused by PE */
  &UNASSIGNED_ISR,                      /* 0x3B  0xFF76   1   ivVpit2        unused by PE */
  &UNASSIGNED_ISR,                      /* 0x3C  0xFF78   1   ivVpit1        unused by PE */
  &UNASSIGNED_ISR,                      /* 0x3D  0xFF7A   1   ivVpit0        unused by PE */
  &UNASSIGNED_ISR,                      /* 0x3E  0xFF7C   1   ivVhti         unused by PE */
  &UNASSIGNED_ISR,                      /* 0x3F  0xFF7E   1   ivVapi         unused by PE */
  &UNASSIGNED_ISR,                      /* 0x40  0xFF80   1   ivVlvi         unused by PE */
  &UNASSIGNED_ISR,                      /* 0x41  0xFF82   1   ivVReserved62  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x42  0xFF84   1   ivVReserved61  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x43  0xFF86   1   ivVReserved60  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x44  0xFF88   1   ivVReserved59  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x45  0xFF8A   1   ivVReserved58  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x46  0xFF8C   1   ivVpwmesdn     unused by PE */
  &UNASSIGNED_ISR,                      /* 0x47  0xFF8E   1   ivVportp       unused by PE */
  &UNASSIGNED_ISR,                      /* 0x48  0xFF90   1   ivVReserved55  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x49  0xFF92   1   ivVReserved54  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x4A  0xFF94   1   ivVReserved53  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x4B  0xFF96   1   ivVReserved52  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x4C  0xFF98   1   ivVReserved51  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x4D  0xFF9A   1   ivVReserved50  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x4E  0xFF9C   1   ivVReserved49  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x4F  0xFF9E   1   ivVReserved48  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x50  0xFFA0   1   ivVReserved47  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x51  0xFFA2   1   ivVReserved46  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x52  0xFFA4   1   ivVReserved45  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x53  0xFFA6   1   ivVReserved44  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x54  0xFFA8   1   ivVReserved43  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x55  0xFFAA   1   ivVReserved42  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x56  0xFFAC   1   ivVReserved41  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x57  0xFFAE   1   ivVReserved40  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x58  0xFFB0   1   ivVcan0tx      unused by PE */
  &UNASSIGNED_ISR,                      /* 0x59  0xFFB2   1   ivVcan0rx      unused by PE */
  &UNASSIGNED_ISR,                      /* 0x5A  0xFFB4   1   ivVcan0err     unused by PE */
  &UNASSIGNED_ISR,                      /* 0x5B  0xFFB6   1   ivVcan0wkup    unused by PE */
  &UNASSIGNED_ISR,                      /* 0x5C  0xFFB8   1   ivVflash       unused by PE */
  &UNASSIGNED_ISR,                      /* 0x5D  0xFFBA   1   ivVflashfd     unused by PE */
  &UNASSIGNED_ISR,                      /* 0x5E  0xFFBC   1   ivVReserved33  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x5F  0xFFBE   1   ivVReserved32  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x60  0xFFC0   1   ivVReserved31  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x61  0xFFC2   1   ivVReserved30  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x62  0xFFC4   1   ivVcrgscm      unused by PE */
  &UNASSIGNED_ISR,                      /* 0x63  0xFFC6   1   ivVcrgplllck   unused by PE */
  &UNASSIGNED_ISR,                      /* 0x64  0xFFC8   1   ivVReserved27  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x65  0xFFCA   1   ivVReserved26  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x66  0xFFCC   1   ivVReserved25  unused by PE */
  &isrVportj,                           /* 0x67  0xFFCE   1   ivVportj       used by PE */
  &UNASSIGNED_ISR,                      /* 0x68  0xFFD0   1   ivVReserved23  unused by PE */
  &UNASSIGNED_ISR,                      /* 0x69  0xFFD2   1   ivVatd0        unused by PE */
  &UNASSIGNED_ISR,                      /* 0x6A  0xFFD4   1   ivVsci1        unused by PE */
  &UNASSIGNED_ISR,                      /* 0x6B  0xFFD6   1   ivVsci0        unused by PE */
  &isrVspi0,                            /* 0x6C  0xFFD8   1   ivVspi0        used by PE */
  &UNASSIGNED_ISR,                      /* 0x6D  0xFFDA   1   ivVtimpaie     unused by PE */
  &UNASSIGNED_ISR,                      /* 0x6E  0xFFDC   1   ivVtimpaaovf   unused by PE */
  &UNASSIGNED_ISR,                      /* 0x6F  0xFFDE   1   ivVtimovf      unused by PE */
  &UNASSIGNED_ISR,                      /* 0x70  0xFFE0   1   ivVtimch7      unused by PE */
  &UNASSIGNED_ISR,                      /* 0x71  0xFFE2   1   ivVtimch6      unused by PE */
  &UNASSIGNED_ISR,                      /* 0x72  0xFFE4   1   ivVtimch5      unused by PE */
  &UNASSIGNED_ISR,                      /* 0x73  0xFFE6   1   ivVtimch4      unused by PE */
  &UNASSIGNED_ISR,                      /* 0x74  0xFFE8   1   ivVtimch3      unused by PE */
  &UNASSIGNED_ISR,                      /* 0x75  0xFFEA   1   ivVtimch2      unused by PE */
  &UNASSIGNED_ISR,                      /* 0x76  0xFFEC   1   ivVtimch1      unused by PE */
  &UNASSIGNED_ISR,                      /* 0x77  0xFFEE   1   ivVtimch0      unused by PE */
  &UNASSIGNED_ISR,                      /* 0x78  0xFFF0   1   ivVrti         unused by PE */
  &UNASSIGNED_ISR,                      /* 0x79  0xFFF2   1   ivVirq         unused by PE */
  &UNASSIGNED_ISR,                      /* 0x7A  0xFFF4   -   ivVxirq        unused by PE */
  &UNASSIGNED_ISR,                      /* 0x7B  0xFFF6   -   ivVswi         unused by PE */
  &UNASSIGNED_ISR                       /* 0x7C  0xFFF8   -   ivVtrap        unused by PE */
};

/*lint -save  -e950 Disable MISRA rule (1.1) checking. */
static const tIsrFunc _ResetVectorTable[] @0xFFFAU = { /* Reset vector table */
/*lint -restore Enable MISRA rule (1.1) checking. */
  /* Reset handler name                    Address Name            Description */
  &MCU_init_reset,                      /* 0xFFFA  ivVcop          unused by PE */
  &MCU_init_reset,                      /* 0xFFFC  ivVclkmon       unused by PE */
  &MCU_init_reset                       /* 0xFFFE  ivVreset        used by PE */
};


/* END MCUinit */

/*
** ###################################################################
**
**     This file was created by Processor Expert 3.02 [04.44]
**     for the Freescale HCS12X series of microcontrollers.
**
** ###################################################################
*/
