/*******************************************************************
* Copyright (c) 2010 Beijing Jiaotong University
* All rights reserved.
*
* File Name	NRF24L01.c
* Description	This file provides all the functions of NRF24L01.c
* Version	0.1
* Author	Suiris
* Date		01/15/2010
********************************************************************/

/* Includes ---------------------------------------------------*/
#include "NRF24L01.h"
/* Private typedef --------------------------------------------*/
/* Private define ---------------------------------------------*/
#define RX_DR	sta&0x40
#define TX_DS	sta&0x20
#define MAX_RT sta&0x10
#define TX_FULL sta&0x01
/* Private macro ----------------------------------------------*/
/* Private variables ------------------------------------------*/
NRF24L01INITSTRUCT NRF24L01init={
	{0x00,0x01,0x02,0x03,0x04},//͵ַ
	{0x00,0x01,0x02,0x03,0x04},//յַ
	3,//0dBm
	1,//2Mbps
	0,//ŵ1
};
/* Extern variables -------------------------------------------*/
unsigned char sta;
unsigned char NRF24L01P_Buffer_Tx[RX_PLOAD_WIDTH]={8,1,2,3,4,5,6,7,8};
unsigned char NRF24L01P_Buffer_Rx[TX_PLOAD_WIDTH]={0};
/* Private function prototypes --------------------------------*/
void inerDelay_us(unsigned long n);
unsigned char SPI_RW(unsigned char byte);
unsigned char SPI_Read(unsigned char reg);
/* Private functions ------------------------------------------*/
/****************************************************************
* Function Name	: init_NRF24L01
* Description		: NRF24L01ʼ
* Input					: None
* Output				 : None
* Return				 : None
*****************************************************************/
void init_NRF24L01_Default(void){
	inerDelay_us(100);
	RESET_CE;
	RESET_CSN;
	sta = SPI_RW(0xff);
	SET_CSN;
	SPI_Write_Buf(NRF24L01_WRITE_REG + TX_ADDR, NRF24L01init.TX_Addr, TX_ADR_WIDTH);		// дصַ
	SPI_Write_Buf(NRF24L01_WRITE_REG + RX_ADDR_P0, NRF24L01init.RX_Addr, RX_ADR_WIDTH); // дն˵ַ
	SPI_RW_Reg(NRF24L01_WRITE_REG + EN_AA, 0x01);			//	Ƶ0Զ	ACKӦ
	SPI_RW_Reg(NRF24L01_WRITE_REG + EN_RXADDR, 0x01);	//	յַֻƵ0ҪƵԲοPage21
	SPI_RW_Reg(NRF24L01_WRITE_REG + RF_CH, 0);				//	 ŵΪ2.4GHZշһ
	SPI_RW_Reg(NRF24L01_WRITE_REG + RX_PW_P0, RX_PLOAD_WIDTH); //ýݳȣΪ32ֽ
	SPI_RW_Reg(NRF24L01_WRITE_REG + RF_SETUP, 0x0E); //÷Ϊ2Mbps书Ϊֵ0dB
	SET_CE;
	//SPI_RW_Reg(FLUSH_RX,0);
	//SPI_RW_Reg(FLUSH_TX,0);
	SPI_RW_Reg(NRF24L01_WRITE_REG+STATUS,sta|0x70);
}
/****************************************************************
* Function Name	: Reinit_NRF24L01
* Description		: NRF24L01سʼ
* Input					: NRF24L01INITSTRUCT
* Output				 : None
* Return				 : None
*****************************************************************/
void Reinit_NRF24L01(NRF24L01INITSTRUCT init){
	unsigned char RFSETUP,i;
	RFSETUP=((init.RF_PWR&0x3)<<1)|(init.Speed&0x1)<<3|(((init.Speed>>1)&1)<<5);
	for(i=0;i<5;++i){
		NRF24L01init.TX_Addr[i]=init.TX_Addr[i];
		NRF24L01init.RX_Addr[i]=init.RX_Addr[i];
	}
	inerDelay_us(100);
	RESET_CE;
	RESET_CSN;
	sta = SPI_RW(0xff);
	SET_CSN;
	SPI_Write_Buf(NRF24L01_WRITE_REG + TX_ADDR, init.TX_Addr, TX_ADR_WIDTH);		// дصַ
	SPI_Write_Buf(NRF24L01_WRITE_REG + RX_ADDR_P0, init.RX_Addr, RX_ADR_WIDTH); // дն˵ַ
	SPI_RW_Reg(NRF24L01_WRITE_REG + EN_AA, 0x01);			//	Ƶ0Զ	ACKӦ
	SPI_RW_Reg(NRF24L01_WRITE_REG + EN_RXADDR, 0x01);	//	յַֻƵ0ҪƵԲοPage21
	SPI_RW_Reg(NRF24L01_WRITE_REG + RF_CH, init.WireLessChannel);				//	 ŵΪ2.4GHZշһ
	SPI_RW_Reg(NRF24L01_WRITE_REG + RX_PW_P0, RX_PLOAD_WIDTH); //ýݳȣΪ32ֽ
	SPI_RW_Reg(NRF24L01_WRITE_REG + RF_SETUP, RFSETUP); //÷Ϊ1Mbps书Ϊֵ0dB
	SET_CE;
	SPI_RW_Reg(FLUSH_RX,0);
	SPI_RW_Reg(FLUSH_TX,0);
	SPI_RW_Reg(NRF24L01_WRITE_REG+STATUS,sta|0x70);
}
/****************************************************************
* Function Name	: inerDelay_us
* Description		: ʱ
* Input					: - n: Description of the parameter.
* Output				 : None
* Return				 : None
*****************************************************************/
void inerDelay_us(unsigned long n){
	unsigned long i;
	for(;n>0;n--)
		for(i=0;i<100;i++);
}
/****************************************************************
* Function Name	: SPI_RW
* Description		: NRF24L01SPIд
* Input					: - byte: Description of the parameter.
* Output				 : None
* Return				 : None
*****************************************************************/
unsigned char SPI_RW(unsigned char buff){
	while (!SPI0SR_SPTEF);
	SPI0DRL=buff;
	while(!(SPI0SR_SPIF));
	return SPI0DRL;								// return read unsigned char
}
/****************************************************************
* Function Name	: SPI_Read
* Description		: NRF24L01Ĵ
* Input					: - reg: Description of the parameter.
* Output				 : None
* Return				 : None
*****************************************************************/
unsigned char SPI_Read(unsigned char reg)
{
	while (!SPI0SR_SPTEF);
	SPI0DRL=reg;
	while(!(SPI0SR_SPIF));
	return SPI0DRL;					// return register value
}
/****************************************************************
* Function Name	: SPI_RW_Reg
* Description		: NRF24L01дĴ
* Input					: - regĴַ
*								: - value
* Output				: None
* Return				: nRF24L01 status uchar
*****************************************************************/
unsigned char SPI_RW_Reg(unsigned char reg, unsigned char value)
{
	unsigned char status;
	RESET_CSN;									 // CSN low, init SPI transaction
	status = SPI_RW(reg);			// select register
	SPI_RW(value);						 // ..and write value to it..
	SET_CSN;									 // CSN high again
	return(status);						// return nRF24L01 status uchar
}
/****************************************************************
* Function Name	: SPI_Read_Buf                    
* Description		: ڶ
* Input					: - regĴַ
*								: - pBufݵַ
*								: - ucharsݵĸ.
* Output				 : None
* Return				 : - statusnRF24L01 status uchar
*****************************************************************/
unsigned char SPI_Read_Buf(unsigned char reg, unsigned char *pBuf, unsigned char uchars){
	unsigned char status,uchar_ctr;
	RESET_CSN;										// Set CSN low, init SPI tranaction
	status = SPI_RW(reg);					// Select register to write to and read status uchar
	for(uchar_ctr=0;uchar_ctr<uchars;uchar_ctr++)
		pBuf[uchar_ctr] = SPI_RW(0);
	SET_CSN;											// Set CSN High, exit SPI tranaction
	return(status);										// return nRF24L01 status uchar
}
/****************************************************************
* Function Name	: SPI_Write_Buf
* Description		: д
* Input					: - regĴַ
*								: - pBufݵַ
*								: - ucharsݵĸ.
* Output				 
: None
* Return				 : - statusnRF24L01 status uchar
*****************************************************************/
unsigned char SPI_Write_Buf(unsigned char reg, unsigned char *pBuf, unsigned char uchars)
{
	unsigned char status,uchar_ctr;
	RESET_CSN;						//SPIʹ
	status = SPI_RW(reg);
	for(uchar_ctr=0; uchar_ctr<uchars; uchar_ctr++)
		SPI_RW(*pBuf++);
	SET_CSN;					 //رSPI
	return(status);		//
}
/****************************************************************
* Function Name	: SetRX_Mode
* Description		: ݽ
* Input					: None
* Output				 : None
* Return				 : None
*****************************************************************/
void SetRX_Mode(void)
{
	RESET_CE;			//StandBy Iģʽ
	SPI_RW_Reg(NRF24L01_WRITE_REG + CONFIG, 0x0f);			 // IRQշжӦ16λCRC	
	SET_CE;
	inerDelay_us(130);		//ʱ̫
}
/****************************************************************
* Function Name	: nRF24L01_RxPacket
* Description		: ݶȡrx_bufջ
* Input					: - rx_bufջַ.
* Output				 : - revaleȡɱ־
* Return				 : None
*****************************************************************/
unsigned char nRF24L01_RxPacket(unsigned char* rx_buf)
{
	unsigned char revale=0;
	RESET_CE;		 	//StandBy 1ģʽ
	RESET_CSN;
	sta=SPI_Read(STATUS);	// ȡ״̬Ĵжݽ״
	SET_CSN;
	if(RX_DR)				// жǷյ
	{
		SPI_Read_Buf(RD_RX_PLOAD,rx_buf,RX_PLOAD_WIDTH);// read receive payload from RX_FIFO buffer
		SPI_RW_Reg(FLUSH_RX,0);
		revale=1;			//ȡɱ־
	}
	RESET_CE;
	SPI_RW_Reg(NRF24L01_WRITE_REG+STATUS,sta|0x70);	 //յݺRX_DR,TX_DS,MAX_PTøΪ1ͨд1жϱ־
	SET_CE;
	return revale;
}
/****************************************************************
* Function Name	: nRF24L01_TxPacket
* Description		:  tx_buf
* Input					: - tx_buf:
* Output				 : None
* Return				 : None
*****************************************************************/
void nRF24L01_TxPacket(unsigned char* tx_buf)
{
	RESET_CE;			//StandBy Iģʽ
	SPI_RW_Reg(FLUSH_TX,0);
	SPI_RW_Reg(NRF24L01_WRITE_REG + CONFIG, 0x0e);	 		 // IRQշжӦ16λCRC
	SPI_Write_Buf(NRF24L01_WRITE_REG + RX_ADDR_P0, NRF24L01init.TX_Addr, TX_ADR_WIDTH); // װؽն˵ַ
	sta=SPI_Write_Buf(WR_TX_PLOAD, tx_buf, TX_PLOAD_WIDTH);		 	 // װ	
	SET_CE;		//øCEݷ
	inerDelay_us(50);
}
