/***************************************************************
* Copyright (c) 2010 Beijing Jiaotong University
* All rights reserved.
*
* File Name	NRF24L01.h
* Description	This file contains the headers of NRF24L01.c
* Version	0.1
* Author	Suiris
* Date		01/15/2010
****************************************************************/

/* Define to prevent recursive inclusion ------------------*/
#ifndef NRF24L01_H
#define NRF24L01_H
/* Includes -----------------------------------------------*/
#include <hidef.h>			/* common defines and macros */
#include "derivative.h"			/* derivative-specific definitions */
/* Exported types -----------------------------------------*/
typedef struct{
	unsigned char TX_Addr[5];
	unsigned char RX_Addr[5];
	unsigned char RF_PWR;
	unsigned char Speed;
	unsigned char WireLessChannel;
} NRF24L01INITSTRUCT;

//extern NRF24L01INITSTRUCT NRF24L01init;
/* Private define ---------------------------------------------*/
#define MISO_pin	PTM_PTM2
#define MOSI_pin	PTM_PTM4
#define	CSN_pin		PTM_PTM3
#define	SCK_pin		PTM_PTM5
#define	CE_pin		PTT_PTT4//PORTE_PE7
#define	IRQ_pin		PTJ_PTJ7

#define SET_CE CE_pin=1
#define RESET_CE CE_pin=0
#define SET_CSN CSN_pin=1
#define RESET_CSN CSN_pin=0

/* Exported constants -------------------------------------*/
/*-------NRF24L01-------*/
#define TX_ADR_WIDTH		5	 	// 5 uints TX address width
#define RX_ADR_WIDTH		5	 	// 5 uints RX address width
#define TX_PLOAD_WIDTH	32	// 20 uints TX payload
#define RX_PLOAD_WIDTH	32	// 20 uints TX payload

/*-------NRF24L01Ĵָ-------*/
#define NRF24L01_READ_REG				0x00		// Ĵָ
#define NRF24L01_WRITE_REG			 0x20 	// дĴָ
#define RD_RX_PLOAD		0x61		// ȡָ
#define WR_TX_PLOAD		0xA0		// дָ
#define FLUSH_TX			0xE1		// շ FIFOָ
#define FLUSH_RX			0xE2		// ս FIFOָ
#define REUSE_TX_PL		0xE3		// ظװָ
#define NOP						0xFF		// 
/*-------SPI(nRF24L01)Ĵַ-------*/
#define CONFIG				0x00		// շ״̬CRCУģʽԼշ״̬Ӧʽ
#define EN_AA					0x01		// ԶӦ
#define EN_RXADDR			0x02		// ŵ
#define SETUP_AW			0x03		// շַ
#define SETUP_RETR		0x04		// Զط
#define RF_CH					0x05		// Ƶ
#define RF_SETUP			0x06		// ʡĹ
#define STATUS				0x07		// ״̬Ĵ
#define OBSERVE_TX		0x08		// ͼ⹦
#define CD						0x09		// ַ					
#define RX_ADDR_P0		0x0A		// Ƶ0ݵַ
#define RX_ADDR_P1		0x0B		// Ƶ1ݵַ
#define RX_ADDR_P2		0x0C		// Ƶ2ݵַ
#define RX_ADDR_P3		0x0D		// Ƶ3ݵַ
#define RX_ADDR_P4		0x0E		// Ƶ4ݵַ
#define RX_ADDR_P5		0x0F		// Ƶ5ݵַ
#define TX_ADDR				0x10		// ͵ַĴ
#define RX_PW_P0			0x11		// Ƶ0ݳ
#define RX_PW_P1			0x12		// Ƶ0ݳ
#define RX_PW_P2			0x13		// Ƶ0ݳ
#define RX_PW_P3			0x14		// Ƶ0ݳ
#define RX_PW_P4			0x15		// Ƶ0ݳ
#define RX_PW_P5			0x16		// Ƶ0ݳ
#define FIFO_STATUS		0x17		// FIFOջջ״̬Ĵ

/* Exported macro -----------------------------------------*/
/* Exported variables -------------------------------------*/
extern unsigned char NRF24L01P_Buffer_Rx[RX_PLOAD_WIDTH];
extern unsigned char NRF24L01P_Buffer_Tx[TX_PLOAD_WIDTH];
/* Exported functions -------------------------------------*/
void init_NRF24L01_Default(void);
void Reinit_NRF24L01(NRF24L01INITSTRUCT init);
void inerDelay_us(unsigned long n);
void SetRX_Mode(void);
unsigned char SPI_RW_Reg(unsigned char reg, unsigned char value);
unsigned char SPI_Read_Buf(unsigned char reg, unsigned char *pBuf, unsigned char uchars);
unsigned char SPI_Write_Buf(unsigned char reg, unsigned char *pBuf, unsigned char uchars);
unsigned char nRF24L01_RxPacket(unsigned char* rx_buf);
void nRF24L01_TxPacket(unsigned char * tx_buf);
#endif /* NRF24L01_H */
